<template>
  <div class="files">
    <div class="alert alert-danger" role="alert" v-for="error in errors">{{ error }}</div>

    <ul class="nav nav-tabs" v-show="hasBoilerplate">
      <li role="presentation" v-bind:class="{ active: selectedFilename === file.name }" v-for="file in boilerplateFiles">
        <a href="javascript:void(0)" @click="showFile(file.name)">{{ file.name }}</a>
      </li>
    </ul>

    <div class="code-container" v-show="hasBoilerplate">
      <button type="button" class="btn btn-link btn-clipboard" data-clipboard-target=".code-current">
        <img src="/static/assets/clippy.svg" alt="Copy to clipboard" title="Copy to clipboard" style="width:20px;">
      </button>

      <div class="file-content">
        <div v-highlightjs="file.content" v-for="file in boilerplateFiles" v-show="selectedFilename === file.name">
          <pre><code class="python" v-bind:class="{ 'code-current': selectedFilename === file.name }"></code></pre>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
// import fileGenerator from '../filegenerator'

export default {
  name: 'files',
  data () {
    return {
    }
  },
  computed: {
    ...mapGetters([
      'selectedFilename',
      'hasBoilerplate',
      'boilerplateFiles',
      'errors'
    ])
  },
  methods: mapActions([
    'showFile',
    'generateBoilerplate'
  ])
  // directives: {
  //   highlightjs () {
  //     hljs.highlightBlock(this.el)
  //   }
  // }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.code-container {
  min-width: 400px;
}

.files {
  /*border: 1px solid #DDD;*/
  padding: 20px;
  padding-top: 10px;
  border-radius: 4px;
}

.load-indicator {
  position: absolute;
  left: 38px;
  top: 20px;
}

pre {
  border: 1px solid #ccc;
  border-radius: 4px;
  padding: 0;
}

pre code {
  padding: 0.7rem;
  white-space: pre;
}

.code-container {
  padding: 20px 0px;
}

.btn-clipboard {
  right: 50px;
  position: absolute;
  cursor: pointer;
}

.info {
  margin: 10px 0px;
}
</style>
